#!/usr/bin/env python
# -*- coding: utf-8 -*-
"""
$Id: wash.py,v 1.2 2014/06/06 11:52:30 alfille Exp $

Copyright (c) 2014 C-Bell (VAGor). All rights reserved.

Программа перегонки сахарной браги

"""

import actuators, sqlite3, time, DS18B20db, Power
from actuators import *

#Отключение всех реле
OffAll()
print("Отключение всех реле")

#Продувка
OnDeph()
OnCond()
time.sleep(1)
OffAll()

#Запуск процесса сбора температурных данных
DS18B20db.StartMeasure()
print("Процесс сбора температур запущен")

#Мощность на ТЭНы
P=10

#Установка полной мощности
Power.Set(P)

#Запуск преобразования Брезенхема
Power.On()
print("Включение 100% нагрева")

#Cоединение с базой данных
db_con=sqlite3.connect("Distiller.db")
#Создание курсора БД
db_cur=db_con.cursor()

#Нужно подождать пару секунд, ибо измерение температуры не быстро делается
print("Ожидание 2 сек")
time.sleep(2)

#Кубовая температура
T1=0
#Температура в середине колонны
T2=0
#Температура верха колонны
T3=0
#Температура над дефлегматором
T4=0
#Температура после холодильника-конденсатора
T5=0
print("Запуск цикла регулирования процесса дистилляции")
while True:
    db_cur.execute("SELECT * FROM DS18B20cur WHERE Name='Куб'")
    T1=db_cur.fetchone()
    db_cur.execute("SELECT * FROM DS18B20cur WHERE Name='1/2'")
    T2=db_cur.fetchone()
    db_cur.execute("SELECT * FROM DS18B20cur WHERE Name='Верх'")
    T3=db_cur.fetchone()
    db_cur.execute("SELECT * FROM DS18B20cur WHERE Name='Деф'")
    T4=db_cur.fetchone()
    db_cur.execute("SELECT * FROM DS18B20cur WHERE Name='Конд'")
    T5=db_cur.fetchone()

    #Если температура на выходе холодильника-конденсатора>25,
    #включаем охлаждение. Иначе отключаем.
    if T5[2]>25:
        OnCond()
    else:
        OffCond()

    #Если температура на выходе дефлегматора>70,
    #включаем охлаждение. Иначе отключаем.
    if T4[2]>70:
        OnDeph()
    else:
        OffDeph()

    #Подаем мощность, соответствующую температуре в кубе
    if T1[2]<70:
        P=10
    elif T1[2]<74:
       P=2
    elif T1[2]<83:
       P=3
##    elif T1[2]<83:
##        P=4
    else:
        Power.Off()
        OffAll()
        break
    Power.Set(P)
    print("%s %s %s, %s %s %s, %s %s %s, %s %s %s, %s %s %s" % (T1[0],T1[1],T1[2],T2[0],T2[1],T2[2],T3[0],T3[1],T3[2],T4[0],T4[1],T4[2],T5[0],T5[1],T5[2]))
    time.sleep(1.2)

print("Процесс дистилляции завершен")
#Отключаем нарев
Power.Off()
print("Регулятор мощности останолен")

#Продувка
OnCond()
OnDeph()
time.sleep(1)

#Отключаем всё
OffAll()
print("Все реле отключены")
#Останавливаем запись температур в БД
DS18B20db.StopMeasure()
print("Процесс сбора температур остановлен")

